﻿using System;
using System.Xml;
using System.Xml.Serialization;

namespace XmlSerializersTest.Serializers
{
    class StandardXmlSerializer : IXmlSerializer
    {
        public string Name { get { return "Standard"; } }

        public void Serialize(object obj, XmlWriter writer)
        {
            var serializer = new XmlSerializer(obj.GetType());
            serializer.Serialize(writer, obj, GetNamespaces());
        }

        public object Deserialize(XmlReader reader, Type typeToDeserialize)
        {
            var serializer = new XmlSerializer(typeToDeserialize);
            return serializer.Deserialize(reader);
        }

        private static XmlSerializerNamespaces GetNamespaces()
        {
            var result = new XmlSerializerNamespaces();
            result.Add("", "");
            return result;
        }
    }
}
