﻿using System;
using System.Runtime.Serialization;
using System.Xml;

namespace XmlSerializersTest.Serializers
{
    class WcfSerializer : IXmlSerializer
    {
        private readonly bool _preserveReferences;

        public string Name { get { return _preserveReferences?"WCF-ref" : "WCF"; } }

        public WcfSerializer(bool preserveReferences)
        {
            _preserveReferences = preserveReferences;
        }

        public void Serialize(object obj, XmlWriter writer)
        {
            var serializer = 
                _preserveReferences?
                    new DataContractSerializer(obj.GetType(), null, int.MaxValue, true, true, null)
                    :
                    new DataContractSerializer(obj.GetType());
            serializer.WriteObject(writer, obj);
        }

        public object Deserialize(XmlReader reader, Type typeToDeserialize)
        {
            var serializer = new DataContractSerializer(typeToDeserialize);
            return serializer.ReadObject(reader);
        }
    }
}
